<?php


/*
 * @version $Id: dropdownValue.php 3825 2006-08-25 16:01:22Z moyo $
 ------------------------------------------------------------------------- 
 GLPI - Gestionnaire Libre de Parc Informatique 
 Copyright (C) 2003-2008 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Julien Dombre
// Purpose of file:
// ----------------------------------------------------------------------

// Direct access to file
if(strpos($_SERVER['PHP_SELF'],"dropdownValue.php")){
	define('GLPI_ROOT', '../../..');
	//$AJAX_INCLUDE = 1;
	include (GLPI_ROOT . "/inc/display.function.php");
	header("Content-Type: text/html; charset=UTF-8");
	header_nocache();
};
include (GLPI_ROOT . "/inc/includes.php");
include_once (GLPI_ROOT . "/plugins/rack/locales/" . $_SESSION["glpilanguage"] . ".php");

useplugin('rack',true);

if (!defined('GLPI_ROOT')) {
	die("Can not acces directly to this file");
}

checkLoginUser();

// Security
if (! TableExists($_POST['table']) ){
	exit();
}

// Make a select box with preselected values
if (!isset ($_POST["limit"]))
	$_POST["limit"] = $CFG_GLPI["dropdown_limit"];
$first = true;
$where = "WHERE ";

if (in_array($_POST['table'], $CFG_GLPI["deleted_tables"])) {
	if (!$first)
		$where .= " AND ";
	else
		$first = false;
	$where .= " `deleted` = '0' ";
}
if (in_array($_POST['table'], $CFG_GLPI["template_tables"])) {
	if (!$first)
		$where .= " AND ";
	else
		$first = false;
	$where .= " `is_template` = '0' ";
}

$NBMAX = $CFG_GLPI["dropdown_max"];
$LIMIT = "LIMIT 0,$NBMAX";
if ($_POST['searchText'] == $CFG_GLPI["ajax_wildcard"])
	$LIMIT = "";

if (!$first)
	$where .= " AND ";
else
	$first = false;

//why ?
if(in_array($_POST['devicetype'], plugin_rack_getTypes())){
	
	$where .= " `" . $LINK_ID_TABLE[$_POST["devicetype"]] . "`.`ID` <> '" . $_POST['value'] . "' ";
	
	if (in_array($LINK_ID_TABLE[$_POST['devicetype']],$CFG_GLPI["specif_entities_tables"])){

			$multi=in_array($LINK_ID_TABLE[$_POST['devicetype']],$CFG_GLPI["recursive_type"]);

			$field="`FK_entities`";
			$add_order=" `FK_entities`, ";

			if (isset($_POST["entity_restrict"]) && !($_POST["entity_restrict"]<0)){
				$where.=getEntitiesRestrictRequest(" AND ",$LINK_ID_TABLE[$_POST['devicetype']],$field,$_POST["entity_restrict"]);
				if (is_array($_POST["entity_restrict"]) && count($_POST["entity_restrict"])>1) {
					$multi=true;	
				}
			} else {
				$where.=getEntitiesRestrictRequest(" AND ",$LINK_ID_TABLE[$_POST['devicetype']],$field);
				if (count($_SESSION['glpiactiveentities'])>1) {
					$multi=true;	
				}
			}
		}
	
	$field = "name";
	
	if ($_POST['searchText'] != $CFG_GLPI["ajax_wildcard"])
		$where .= " AND $field " .
		makeTextSearch($_POST['searchText']);
	
	$where .= " AND `" . $LINK_ID_TABLE[$_POST['devicetype']] . "`.`ID` NOT IN (0";
	$where .= plugin_rack_findItems($DB, $_POST['devicetype']);
	$where .= ") ";
	
	$query = "SELECT `" . $LINK_ID_TABLE[$_POST['devicetype']] . "`.`name` AS name,`" . $LINK_ID_TABLE[$_POST['devicetype']] . "`.`FK_entities` AS FK_entities,`" . $LINK_ID_TABLE[$_POST['devicetype']] . "`.`ID`, `glpi_plugin_rack_device_spec`.`ID` AS spec " .
			" FROM `glpi_plugin_rack_device_spec`,`" . $LINK_ID_TABLE[$_POST['devicetype']] . "` " .
			" $where AND `glpi_plugin_rack_device_spec`.`FK_model` = `" . $LINK_ID_TABLE[$_POST['devicetype']] . "`.`model` 
			AND `glpi_plugin_rack_device_spec`.`device_type` = '" . $_POST['devicetype'] . "' " .
			" ORDER BY $add_order  `" . $LINK_ID_TABLE[$_POST['devicetype']] . "`.`name` $LIMIT";
	$result = $DB->query($query);

}else{
	$multi=false;
	$query = "SELECT `glpi_dropdown_plugin_rack_others_type`.`ID`,`glpi_dropdown_plugin_rack_others_type`.`name`,`glpi_dropdown_plugin_rack_others_type`.`comments`, `glpi_plugin_rack_device_spec`.`ID` AS spec 
			FROM `glpi_dropdown_plugin_rack_others_type`,`glpi_plugin_rack_device_spec` 
			WHERE `glpi_plugin_rack_device_spec`.`FK_model` = `glpi_dropdown_plugin_rack_others_type`.`ID` AND `glpi_plugin_rack_device_spec`.`device_type` = '".$_POST['devicetype']."' " .
			" ORDER BY `glpi_dropdown_plugin_rack_others_type`.`name` $LIMIT";
	$result = $DB->query($query);

}
echo "<select id='dropdown_" . $_POST["myname"] . $_POST["rand"] . "' name=\"" . $_POST['myname'] . "\" size='1'>";

if ($_POST['searchText'] != $CFG_GLPI["ajax_wildcard"] && $DB->numrows($result) == $NBMAX)
	echo "<option value=\"0\">--" . $LANG['common'][11] . "--</option>";

echo "<option value=\"0\">-----</option>";
$number = $DB->numrows($result);

if ($number != 0)
	$output = getDropdownName($_POST['table'], $_POST['value']);
if (!empty ($output) && $output != "&nbsp;") {
	echo "<option selected value='" . $_POST['value'] . "'>" . $output . "</option>";
}

if ($DB->numrows($result)) {
	$prev=-1;
	while ($data = $DB->fetch_array($result)) {
		$output = $data["name"];
		$ID = $data['ID'];
		$addcomment = "";
		
		if ($multi && $data["FK_entities"]!=$prev) {
			if ($prev>=0) {
				echo "</optgroup>";
			}
			$prev=$data["FK_entities"];
			echo "<optgroup label=\"". getDropdownName("glpi_entities", $prev) ."\">";
		}
		
		$PluginRackModel = new PluginRackModel();
		if($PluginRackModel->GetfromDB($data['spec'])){
			
			$output.= " - ".$PluginRackModel->fields["size"]."U";
		}
				
		if (isset ($data["comments"]))
			$addcomment = " - " . $data["comments"];

		if (empty ($output))
			$output = "($ID)";
			
		echo "<option value=\"" . $_POST['devicetype'] . ";$ID;".$data['spec']."\" title=\"$output$addcomment\">" . substr($output, 0, $_POST["limit"]) . "</option>";
	}
}
echo "</select>";

if (isset($_POST["comments"])&&$_POST["comments"]){
	$paramscomments=array('value'=>'__VALUE__','table'=>$_POST["table"]);
	ajaxUpdateItemOnSelectEvent("dropdown_".$_POST["myname"].$_POST["rand"],"comments_".$_POST["myname"].$_POST["rand"],$CFG_GLPI["root_doc"]."/ajax/comments.php",$paramscomments,false);
}

?>