<?php
/*
   ----------------------------------------------------------------------
   GLPI - Gestionnaire Libre de Parc Informatique
   Copyright (C) 2003-2005 by the INDEPNET Development Team.

   http://indepnet.net/   http://glpi-project.org/
   ----------------------------------------------------------------------

   LICENSE

   This file is part of GLPI.

   GLPI is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GLPI is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GLPI; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Béchu Philippe
// Purpose of file:
// ----------------------------------------------------------------------

$NEEDED_ITEMS = array (
	"computer",
	"printer",
	"networking",
	"monitor",
	"software",
	"peripheral",
	"phone",
	"tracking",
	"document",
	"user",
	"enterprise",
	"contract",
	"infocom",
	"group",
	"setup"
);
define('GLPI_ROOT', '../../..');
include (GLPI_ROOT . "/inc/includes.php");

useplugin('rack',true);

if(!isset($_GET["ID"]))
	$_GET["ID"] = "";
if (!isset ($_GET["withtemplate"]))
	$_GET["withtemplate"] = "";

$PluginRack = new PluginRack;

if (isset ($_POST["add"])) {
	if (plugin_rack_haveRight("rack", "w"))
		$newID = $PluginRack->add($_POST);
	glpi_header($_SERVER['HTTP_REFERER']);
}
elseif (isset ($_POST["delete"])) {
	if (plugin_rack_haveRight("rack", "w"))
		$PluginRack->delete($_POST);
	glpi_header($CFG_GLPI["root_doc"] . "/plugins/rack/index.php");
}
elseif (isset ($_POST["restore"])) {
	if (plugin_rack_haveRight("rack", "w"))
		$PluginRack->restore($_POST);
	glpi_header($CFG_GLPI["root_doc"] . "/plugins/rack/index.php");
}
elseif (isset ($_POST["purge"])) {
	if (plugin_rack_haveRight("rack", "w"))
		$PluginRack->delete($_POST, 1);
	glpi_header($CFG_GLPI["root_doc"] . "/plugins/rack/index.php");
}
elseif (isset ($_POST["update"])) {
	if (plugin_rack_haveRight("rack", "w"))
		$PluginRack->update($_POST);
	glpi_header($_SERVER['HTTP_REFERER']);
}
elseif (isset ($_POST["addDevice"])) {

	if (!isset ($_POST['rack_size'])) {
		$PluginRack = new PluginRack;
		$PluginRack->getFromDB($_POST['FK_rack']);
		$_POST['rack_size'] = $PluginRack->fields['rack_size'];
	}

	$test = explode(";", $_POST['type']);
	$_POST['type'] = $test[0];
	$_POST['item'] = $test[1];
	$_POST['spec'] = $test[2];
	
	if ($_POST['type']==PLUGIN_RACK_OTHERS_TYPE){
		$newid=plugin_rack_addOthers($_POST['item']);
		$_POST['item']=$newid;
	}

	if ($_POST['type'] > 0 && $_POST['item'] > 0 && !empty ($_POST['pos'])) {
		if (plugin_rack_haveRight("rack", "w"))
			$space_left = plugin_rack_addDevice($_POST['FK_rack'], $_POST['rack_size'], $_POST['FK_face'], $_POST['item'], $_POST['type'], $_POST['spec'], $_POST['pos']);
		if ($space_left < 0)
			addMessageAfterRedirect($LANG['plugin_rack'][21],false,ERROR);
	}
	
	glpi_header($_SERVER['HTTP_REFERER']);
	
} elseif (isset ($_POST["deleteDevice"])) {

	if (plugin_rack_haveRight("rack", "w"))
		foreach ($_POST["item"] as $key => $val) {
			if ($val == 1) {
				plugin_rack_deleteDevice($key);
			}
		}
	glpi_header($_SERVER['HTTP_REFERER']);
} elseif (isset ($_GET["deleteDevice"])) {

	if (plugin_rack_haveRight("rack", "w"))
		plugin_rack_deleteDevice($_GET['ID']);

	glpi_header($_SERVER['HTTP_REFERER']);
} elseif (isset ($_POST["update_server"])) {

	if (plugin_rack_haveRight("rack", "w")) {

		foreach ($_POST["updateDevice"] as $key => $val) {
				
				$vartype = "type" . $key;
				$varspec = "FK_spec" . $key;
				$varname = "name" . $key;
				$varFK_device = "FK_device" . $key;
				if ($_POST[$vartype]==PLUGIN_RACK_OTHERS_TYPE)
					plugin_rack_updateOthers($_POST[$varFK_device],$_POST[$varname]);
				$varpos = "position" . $key;
				$varalim1 = "first_powersupply" . $key;
				$varalim2 = "second_powersupply" . $key;
				$varamps = "amps" . $key;
				$varflow_rate = "flow_rate" . $key;
				$vardissipation = "dissipation" . $key;
				$varweight = "weight" . $key;

				$space_left = plugin_rack_updateDevice($key, $_POST[$vartype], $_POST[$varspec],$_POST['FK_rack'], $_POST['rack_size'], $_POST['FK_face'], $_POST[$varFK_device], $_POST[$varpos], $_POST[$varalim1], $_POST[$varalim2], $_POST[$varamps], $_POST[$varflow_rate], $_POST[$vardissipation], $_POST[$varweight]);
		}
	}
	if ($space_left < 0)
		addMessageAfterRedirect($LANG['plugin_rack'][21],false,ERROR);
	glpi_header($_SERVER['HTTP_REFERER']);

} else {
	plugin_rack_checkRight("rack", "r");

	if (!isset($_SESSION['glpi_tab'])) $_SESSION['glpi_tab']=1;
	if (isset($_GET['onglet'])) {
		$_SESSION['glpi_tab']=$_GET['onglet'];
		//		glpi_header($_SERVER['HTTP_REFERER']);
	}

	commonHeader($LANG['plugin_rack']['title'][1], $_SERVER["PHP_SELF"], "plugins", "rack");

	$PluginRack->showForm($_SERVER["PHP_SELF"], $_GET["ID"], $_GET["withtemplate"]);

	commonFooter();
}
		
?>