<?php
/*
 * @version $Id: hook.php 7355 2008-10-03 15:31:00Z moyo $
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copynetwork (C) 2003-2006 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: DOMBRE Julien
// Purpose of file:
// ----------------------------------------------------------------------

foreach (glob(GLPI_ROOT . '/plugins/rack/inc/*.php') as $file)
	include_once ($file);

function plugin_rack_install(){

	include_once (GLPI_ROOT."/inc/profile.class.php");

	if(!TableExists("glpi_plugin_rack_profiles") ){

		plugin_rack_installing("1.0.2");

	}elseif(TableExists("glpi_plugin_rack_content") && !FieldExists("glpi_plugin_rack_content","first_powersupply")){

		plugin_rack_update("1.0.2");

	}

	plugin_rack_createFirstAccess($_SESSION['glpiactiveprofile']['ID']);
	return true;
}

function plugin_rack_uninstall(){
	global $DB;

	foreach (array (
			"glpi_plugin_rack",
			"glpi_plugin_rack_content",
			"glpi_plugin_rack_profiles",
			"glpi_plugin_rack_device_spec",
			"glpi_dropdown_plugin_rack_room_locations",
			"glpi_dropdown_plugin_rack_ways",
			"glpi_plugin_rack_config",
			"glpi_plugin_rack_others",
			"glpi_dropdown_plugin_rack_others_type"
		) as $table)
		$DB->query("DROP TABLE `$table`;");

	$DB->query("DELETE FROM `glpi_display` WHERE `type` = '" . PLUGIN_RACK_TYPE . "';");

	foreach (array("glpi_doc_device","glpi_bookmark","glpi_history") as $table)
		$DB->query("DELETE FROM `$table` WHERE `device_type` = '" . PLUGIN_RACK_TYPE . "';");

	plugin_init_rack();
	cleanCache("GLPI_HEADER_".$_SESSION["glpiID"]);

	return true;
}

// Define dropdown relations
function plugin_rack_getDatabaseRelations(){

	$plugin = new Plugin();
	if ($plugin->isActivated("rack"))
		return array("glpi_dropdown_plugin_rack_room_locations"=>array("glpi_plugin_rack_content"=>"position"),
					 "glpi_dropdown_plugin_rack_ways"=>array("glpi_plugin_rack_content"=>"first_powersupply"),
					 "glpi_dropdown_plugin_rack_ways"=>array("glpi_plugin_rack_content"=>"second_powersupply"),
					 "glpi_dropdown_plugin_rack_others_type"=>array("glpi_plugin_rack_others"=>"type"));
	else
		return array();
}

// Define Dropdown tables to be manage in GLPI :
function plugin_rack_getDropdown(){
	// Table => Name
	global $LANG;
	$plugin = new Plugin();
	if ($plugin->isActivated("rack"))
		return array("glpi_dropdown_plugin_rack_room_locations"=>$LANG['plugin_rack'][11],"glpi_dropdown_plugin_rack_ways"=>$LANG['plugin_rack']['device'][1],"glpi_dropdown_plugin_rack_others_type"=>$LANG['plugin_rack'][43]);
	else
		return array();
}

// Define search option for types of the plugins
function plugin_rack_getSearchOption() {
	global $LANG;
	$sopt = array ();

	if (plugin_rack_haveRight("rack", "r")) {
		// Part header
		$sopt[PLUGIN_RACK_TYPE]['common'] = $LANG['plugin_rack']['title'][1];

		$sopt[PLUGIN_RACK_TYPE][1]['table'] = 'glpi_plugin_rack';
		$sopt[PLUGIN_RACK_TYPE][1]['field'] = 'name';
		$sopt[PLUGIN_RACK_TYPE][1]['linkfield'] = 'name';
		$sopt[PLUGIN_RACK_TYPE][1]['name'] = $LANG['plugin_rack'][5];
		$sopt[PLUGIN_RACK_TYPE][1]['datatype']='itemlink';

		$sopt[PLUGIN_RACK_TYPE][2]['table'] = 'glpi_dropdown_locations';
		$sopt[PLUGIN_RACK_TYPE][2]['field'] = 'completename';
		$sopt[PLUGIN_RACK_TYPE][2]['linkfield'] = 'FK_location';
		$sopt[PLUGIN_RACK_TYPE][2]['name'] = $LANG['plugin_rack'][3];

		$sopt[PLUGIN_RACK_TYPE][3]['table'] = 'glpi_dropdown_plugin_rack_room_locations';
		$sopt[PLUGIN_RACK_TYPE][3]['field'] = 'name';
		$sopt[PLUGIN_RACK_TYPE][3]['linkfield'] = 'room_location';
		$sopt[PLUGIN_RACK_TYPE][3]['name'] = $LANG['plugin_rack'][11];

		$sopt[PLUGIN_RACK_TYPE][4]['table'] = 'glpi_plugin_rack';
		$sopt[PLUGIN_RACK_TYPE][4]['field'] = 'rack_size';
		$sopt[PLUGIN_RACK_TYPE][4]['linkfield'] = 'rack_size';
		$sopt[PLUGIN_RACK_TYPE][4]['name'] = $LANG['plugin_rack'][12];
		$sopt[PLUGIN_RACK_TYPE][4]['datatype'] = 'number';

		$sopt[PLUGIN_RACK_TYPE][5]['table'] = 'glpi_dropdown_manufacturer';
		$sopt[PLUGIN_RACK_TYPE][5]['field'] = 'name';
		$sopt[PLUGIN_RACK_TYPE][5]['linkfield'] = 'FK_glpi_enterprise';
		$sopt[PLUGIN_RACK_TYPE][5]['name'] = $LANG['plugin_rack'][2];

		$sopt[PLUGIN_RACK_TYPE][6]['table'] = 'glpi_groups';
		$sopt[PLUGIN_RACK_TYPE][6]['field'] = 'name';
		$sopt[PLUGIN_RACK_TYPE][6]['linkfield'] = 'FK_groups';
		$sopt[PLUGIN_RACK_TYPE][6]['name'] = $LANG['common'][35];

		$sopt[PLUGIN_RACK_TYPE][7]['table'] = 'glpi_users';
		$sopt[PLUGIN_RACK_TYPE][7]['field'] = 'name';
		$sopt[PLUGIN_RACK_TYPE][7]['linkfield'] = 'tech_num';
		$sopt[PLUGIN_RACK_TYPE][7]['name'] = $LANG['common'][10];

		$sopt[PLUGIN_RACK_TYPE][8]['table'] = 'glpi_plugin_rack';
		$sopt[PLUGIN_RACK_TYPE][8]['field'] = 'height';
		$sopt[PLUGIN_RACK_TYPE][8]['linkfield'] = 'height';
		$sopt[PLUGIN_RACK_TYPE][8]['name'] = $LANG['plugin_rack'][40];
		$sopt[PLUGIN_RACK_TYPE][8]['datatype'] = 'decimal';

		$sopt[PLUGIN_RACK_TYPE][9]['table'] = 'glpi_plugin_rack';
		$sopt[PLUGIN_RACK_TYPE][9]['field'] = 'width';
		$sopt[PLUGIN_RACK_TYPE][9]['linkfield'] = 'width';
		$sopt[PLUGIN_RACK_TYPE][9]['name'] = $LANG['plugin_rack'][41];
		$sopt[PLUGIN_RACK_TYPE][9]['datatype'] = 'decimal';

		$sopt[PLUGIN_RACK_TYPE][10]['table'] = 'glpi_plugin_rack';
		$sopt[PLUGIN_RACK_TYPE][10]['field'] = 'depth';
		$sopt[PLUGIN_RACK_TYPE][10]['linkfield'] = 'depth';
		$sopt[PLUGIN_RACK_TYPE][10]['name'] = $LANG['plugin_rack'][42];
		$sopt[PLUGIN_RACK_TYPE][10]['datatype'] = 'decimal';

		$sopt[PLUGIN_RACK_TYPE][11]['table'] = 'glpi_plugin_rack';
		$sopt[PLUGIN_RACK_TYPE][11]['field'] = 'recursive';
		$sopt[PLUGIN_RACK_TYPE][11]['linkfield'] = 'recursive';
		$sopt[PLUGIN_RACK_TYPE][11]['name'] = $LANG['entity'][9];
		$sopt[PLUGIN_RACK_TYPE][11]['datatype'] = 'bool';

		$sopt[PLUGIN_RACK_TYPE][30]['table'] = 'glpi_plugin_rack';
		$sopt[PLUGIN_RACK_TYPE][30]['field'] = 'ID';
		$sopt[PLUGIN_RACK_TYPE][30]['linkfield'] = '';
		$sopt[PLUGIN_RACK_TYPE][30]['name'] = $LANG['common'][2];

		$sopt[PLUGIN_RACK_TYPE][80]['table'] = 'glpi_entities';
		$sopt[PLUGIN_RACK_TYPE][80]['field'] = 'completename';
		$sopt[PLUGIN_RACK_TYPE][80]['linkfield'] = 'FK_entities';
		$sopt[PLUGIN_RACK_TYPE][80]['name'] = $LANG['entity'][0];

		//from core search
		$sopt[COMPUTER_TYPE][4460]['table'] = 'glpi_plugin_rack';
		$sopt[COMPUTER_TYPE][4460]['field'] = 'name';
		$sopt[COMPUTER_TYPE][4460]['linkfield'] = '';
		$sopt[COMPUTER_TYPE][4460]['name'] = $LANG['plugin_rack']['title'][1] . " - " . $LANG['plugin_rack'][5];
		$sopt[COMPUTER_TYPE][4460]['forcegroupby']='1';
		$sopt[COMPUTER_TYPE][4460]['datatype']='itemlink';
		$sopt[COMPUTER_TYPE][4460]['itemlink_type']=PLUGIN_RACK_TYPE;

		$sopt[NETWORKING_TYPE][4460]['table'] = 'glpi_plugin_rack';
		$sopt[NETWORKING_TYPE][4460]['field'] = 'name';
		$sopt[NETWORKING_TYPE][4460]['linkfield'] = '';
		$sopt[NETWORKING_TYPE][4460]['name'] = $LANG['plugin_rack']['title'][1] . " - " . $LANG['plugin_rack'][5];
		$sopt[NETWORKING_TYPE][4460]['forcegroupby']='1';
		$sopt[NETWORKING_TYPE][4460]['datatype']='itemlink';
		$sopt[NETWORKING_TYPE][4460]['itemlink_type']=PLUGIN_RACK_TYPE;

		$sopt[PERIPHERAL_TYPE][4460]['table'] = 'glpi_plugin_rack';
		$sopt[PERIPHERAL_TYPE][4460]['field'] = 'name';
		$sopt[PERIPHERAL_TYPE][4460]['linkfield'] = '';
		$sopt[PERIPHERAL_TYPE][4460]['name'] = $LANG['plugin_rack']['title'][1] . " - " . $LANG['plugin_rack'][5];
		$sopt[PERIPHERAL_TYPE][4460]['forcegroupby']='1';
		$sopt[PERIPHERAL_TYPE][4460]['datatype']='itemlink';
		$sopt[PERIPHERAL_TYPE][4460]['itemlink_type']=PLUGIN_RACK_TYPE;
	}
	return $sopt;
}

//for search
function plugin_rack_addLeftJoin($type, $ref_table, $new_table, $linkfield, & $already_link_tables) {

	switch ($new_table) {
		case "glpi_plugin_rack_content" :
			return " LEFT JOIN `$new_table` ON (`$ref_table`.`ID` = `$new_table`.`FK_rack`) ";
			break;
		case "glpi_plugin_rack" : // From items
			$out = " LEFT JOIN `glpi_plugin_rack_content` ON (`$ref_table`.`ID` = `glpi_plugin_rack_content`.`FK_device` AND `glpi_plugin_rack_content`.`device_type` = '$type') ";
			$out .= " LEFT JOIN `glpi_plugin_rack` ON (`glpi_plugin_rack`.`ID` = `glpi_plugin_rack_content`.`FK_rack`) ";
			return $out;
			break;
	}

	return "";
}

//force groupby for multible links to items
function plugin_rack_forceGroupBy($type) {

	return true;
	switch ($type) {
		case PLUGIN_RACK_TYPE :
			return true;
			break;

	}
	return false;
}

////// SPECIFIC MODIF MASSIVE FUNCTIONS ///////
function plugin_rack_MassiveActions($type) {

	global $LANG;
	switch ($type) {
		case PLUGIN_RACK_TYPE :
			return array (
				// Specific one
				"plugin_rack_transfert" => $LANG['buttons'][48],

			);
			break;
	}

	return array ();
}

function plugin_rack_MassiveActionsDisplay($type, $action) {

	global $LANG, $CFG_GLPI;
	switch ($type) {
		case PLUGIN_RACK_TYPE :
			switch ($action) {

				case "plugin_rack_transfert" :
					dropdownValue("glpi_entities", "FK_entities", '');
					echo "&nbsp;<input type=\"submit\" name=\"massiveaction\" class=\"submit\" value=\"" . $LANG['buttons'][2] . "\" >";
					break;
			}
			break;
	}

	return "";
}

function plugin_rack_MassiveActionsProcess($data) {
	global $LANG, $DB;

	switch ($data['action']) {

		case "plugin_rack_transfert" :
			if ($data['device_type'] == PLUGIN_RACK_TYPE) {
				foreach ($data["item"] as $key => $val) {
					if ($val == 1) {

						$PluginRack = new PluginRack;
						$values["ID"] = $key;
						$values["FK_entities"] = $data['FK_entities'];
						$PluginRack->update($values);
					}
				}
			}
			break;
	}
}

//////////////////////////////

// Hook done on delete item case

function plugin_pre_item_delete_rack($input) {
	if (isset ($input["_item_type_"]))
		switch ($input["_item_type_"]) {
			case PROFILE_TYPE :
				// Manipulate data if needed
				$PluginRackProfile = new PluginRackProfile;
				$PluginRackProfile->cleanProfiles($input["ID"]);
				break;
		}
	return $input;
}

// Hook done on purge item case
function plugin_item_purge_rack($parm) {

	if (in_array($parm["type"], plugin_rack_getTypes())) {
		$PluginRack = new PluginRack;
		$PluginRack->cleanItems($parm["ID"], $parm["type"]);
		return true;
	} else
		return false;

}

// Define headings added by the plugin
function plugin_get_headings_rack($type, $ID, $withtemplate) {

	global $LANG;

	if ($type==PROFILE_TYPE) {
		$prof = new Profile();
		if ($ID>0 && $prof->getFromDB($ID) && $prof->fields['interface']!='helpdesk') {
			return array(
				1 => $LANG['plugin_rack']['title'][1],
				);
		} else {
			return array();
		}
	}

	if (in_array($type, plugin_rack_getTypes())) {
		// template case
		if ($withtemplate) {
			return array();

		// Non template case
		} else  {
			return array(
				1 => $LANG['plugin_rack']['title'][1],
				);
		}
	}
	return false;

}

// Define headings actions added by the plugin
function plugin_headings_actions_rack($type) {

	if (in_array($type, plugin_rack_getTypes())
		|| $type==PROFILE_TYPE) {
		return array (
			1 => "plugin_headings_rack",

		);
	} else
		return false;

}

// action heading
function plugin_headings_rack($type,$ID,$withtemplate=0){

	global $CFG_GLPI,$LANG;

		switch ($type){
			case PROFILE_TYPE :
				$prof=new PluginRackProfile();
				if (!$prof->GetfromDB($ID))
					plugin_rack_createAccess($ID);
				$prof->showForm($CFG_GLPI["root_doc"]."/plugins/rack/front/plugin_rack.profile.php",$ID);
				break;
			default :
				if (in_array($type, plugin_rack_getTypes())){
					echo "<div align='center'>";
					echo plugin_rack_showAssociated($type, $ID);
					echo "</div>";
				}
			break;
		}
}

?>