<?php

/*
   ----------------------------------------------------------------------
   GLPI - Gestionnaire Libre de Parc Informatique
   Copyright (C) 2003-2005 by the INDEPNET Development Team.

   http://indepnet.net/   http://glpi-project.org/
   ----------------------------------------------------------------------

   LICENSE

   This file is part of GLPI.

   GLPI is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GLPI is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GLPI; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Béchu Philippe
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

function plugin_rack_config_modify($unit){

	$DB = new DB;
	$query="UPDATE `glpi_plugin_rack_config`
			SET `unit` = '$unit'
			WHERE `ID` = 1 ;";
	$result = $DB->query($query);

}

function plugin_rack_spec_add($model, $device_type,$nb_alim, $amps, $flow_rate, $size, $dissipation, $weight, $length) {
	global $DB;
	$PluginRackDeviceSpec = new PluginRackDeviceSpec;
	$result = $DB->query("SELECT *
							FROM `glpi_plugin_rack_device_spec`
							WHERE `FK_model` = '" . $model . "'
							AND `device_type` = '" . $device_type . "' ;");


	if (!$DB->numrows($result)) {
		$values["FK_model"]=$model;
		$values["device_type"]=$device_type;
		$values["nb_alim"]=$nb_alim;
		$values["amps"]=$amps;
		$values["flow_rate"]=$flow_rate;
		$values["size"]=$size;
		$values["dissipation"]=$dissipation;
		$values["weight"]=$weight;
		$values["length"]=$length;
		$PluginRackDeviceSpec->add($values);
	}
}

function plugin_rack_spec_update($input) {

	global $DB, $LINK_ID_TABLE;

	$PluginRackDeviceSpec = new PluginRackDeviceSpec;

	//selection de tous les materiels lies au modele
	$query_spec = "SELECT *
					FROM `glpi_plugin_rack_device_spec`
					WHERE `ID` = '" . $input["ID"] . "' ";
	$result_spec = $DB->query($query_spec);

	while($device=$DB->fetch_array($result_spec)) {

		$query_device = "SELECT `" . $LINK_ID_TABLE[$input['device_type']] . "`.`ID` FROM `" . $LINK_ID_TABLE[$input['device_type']] . "`, `glpi_plugin_rack_device_spec` " .
						"WHERE `glpi_plugin_rack_device_spec`.`FK_model` = `" . $LINK_ID_TABLE[$input['device_type']] . "`.`model`
						AND `glpi_plugin_rack_device_spec`.`ID` = '" . $input["ID"] . "'";
		$result_device = $DB->query($query_device);

		while($model=$DB->fetch_array($result_device)) {

			//detail de chaque materiel dans la baie
			$query_content = "SELECT * FROM `glpi_plugin_rack_content` " .
						"WHERE `device_type` = '" . $input['device_type'] . "'
						AND `FK_device` = '" . $model['ID'] . "' ";
			$result_content = $DB->query($query_content);

			while($content=$DB->fetch_array($result_content)) {

				if ($device["amps"]==$content["amps"]
				 && $device["flow_rate"]==$content["flow_rate"]
				 && $device["dissipation"]==$content["dissipation"]
				 && $device["weight"]==$content["weight"]){

					//si les params du materiel sont les memes que le modele alors update
					$PluginRackContent = new PluginRackContent;
					$values["ID"] = $content['ID'];
					$values["flow_rate"] = $input["flow_rate"];
					$values["dissipation"] = $input["dissipation"];
					$values["weight"] = $input["weight"];

					$PluginRackContent->update($values);

				}
			}
		}
	}

	$PluginRackDeviceSpec->update($input);

}

function plugin_rack_spec_delete($ID) {

	global $DB, $LINK_ID_TABLE;

	$query_spec = "SELECT *
					FROM `glpi_plugin_rack_device_spec`
					WHERE `ID` = '" . $ID . "' ";
	$result_spec = $DB->query($query_spec);

	while($device=$DB->fetch_array($result_spec)) {
			$type=$device['device_type'];
			$query_device = "SELECT `" . $LINK_ID_TABLE[$type] . "`.`ID` FROM `" . $LINK_ID_TABLE[$type] . "`, `glpi_plugin_rack_device_spec` " .
							"WHERE `glpi_plugin_rack_device_spec`.`FK_model` = `" . $LINK_ID_TABLE[$type] . "`.`model`
							AND `glpi_plugin_rack_device_spec`.`ID` = '" . $ID . "'";
			$result_device = $DB->query($query_device);
			while($model=$DB->fetch_array($result_device)) {
				$query = "DELETE
							FROM `glpi_plugin_rack_content`
							WHERE `device_type` = '" . $type . "'
							AND `FK_device` ='" . $model['ID'] . "';";
				$result = $DB->query($query);
			}
	}

	$PluginRackDeviceSpec = new PluginRackDeviceSpec;
	$PluginRackDeviceSpec->delete(array("ID"=>$ID));

}

function plugin_rack_checkPosition($FK_rack,$rack_size, $face,$ID, $type, $spec, $position) {

	global $DB, $LINK_ID_TABLE;

	if ($position<=$rack_size && $position>0){
		// Recherche de la taille de l'equipement pour verifier qu'il y a la place pour l'inserer

		$query = "SELECT `" . $LINK_ID_TABLE[$type] . "`.`ID`, `glpi_plugin_rack_device_spec`.*
					FROM `" . $LINK_ID_TABLE[$type] . "`, `glpi_plugin_rack_device_spec` " .
					"WHERE `" . $LINK_ID_TABLE[$type] . "`.`ID` = '$ID' " .
					"AND `glpi_plugin_rack_device_spec`.`FK_model` = `" . $LINK_ID_TABLE[$type] . "`.`model` " .
					"AND `glpi_plugin_rack_device_spec`.`device_type` = '$type'";

		$result = $DB->query($query);

		$server_size=array();

		while($device=$DB->fetch_array($result)) {
			$device_size=$device["size"];
			for ($y=0;$y<$device_size;$y++)
				$server_size[]=$position-$y;
		}


		//tableau des emplacements occupes
		$query_position = "SELECT `glpi_plugin_rack_content`.`position` AS position, `glpi_plugin_rack_device_spec`.`size` AS size
							FROM `glpi_plugin_rack_content`,`glpi_plugin_rack_device_spec`
							WHERE `glpi_plugin_rack_device_spec`.`ID` = `glpi_plugin_rack_content`.`FK_spec`
							AND `glpi_plugin_rack_content`.`FK_device` != '".$ID."'
							AND `glpi_plugin_rack_content`.`FK_rack` = '".$FK_rack."'
							AND `glpi_plugin_rack_content`.`FK_face` ='".$face."' ";
		$result_position = $DB->query($query_position);

		$position_table=array();

		while($data_position=$DB->fetch_array($result_position)) {

			for ($i=0;$i<$data_position['size'];$i++)
				$position_table[]=$data_position['position']-$i;
		}

		$space_left = 0;
		/*echo "items ";
		print_r($server_size);
		echo "<br>not available ";
		print_r($position_table);*/

		foreach ($position_table as $key => $val) {
			foreach ($server_size as $cle => $value) {
				if ($val==$value)
					$space_left = -1;
			}
		}
		//reste a gerer les inclusions en 1 avec size > 1
		if ($device_size>1 && ($position==1 || $position==01))
			$space_left = -1;
	}else{
		$space_left = -1;
	}

	return $space_left;
}

function plugin_rack_addOthers($ID){

	global $DB;

	$PluginRackOthers = new PluginRackOthers;
	$values["FK_entities"] = $_SESSION["glpiactive_entity"];
	$values["model"] = $ID;
	$newid=$PluginRackOthers->add($values);

	return $newid;
}

function plugin_rack_addDevice($FK_rack, $rack_size, $face, $ID, $type, $spec, $position) {

	$space_left = plugin_rack_checkPosition($FK_rack,$rack_size, $face,$ID, $type, $spec, $position);

	if ($space_left >= 0) {
		$PluginRackContent = new PluginRackContent;
		$values["FK_rack"] = $FK_rack;
		$values["FK_face"] = $face;
		$values["FK_device"] = $ID;
		$values["FK_spec"] = $spec;
		$values["device_type"] = $type;
		$values["position"] = $position;

		$PluginRackDeviceSpec = new PluginRackDeviceSpec;
		$PluginRackDeviceSpec->GetfromDB($spec);

		$values["amps"]=$PluginRackDeviceSpec->fields["amps"];
		$values["flow_rate"]=$PluginRackDeviceSpec->fields["flow_rate"];
		$values["dissipation"] =$PluginRackDeviceSpec->fields["dissipation"];
		$values["weight"] = $PluginRackDeviceSpec->fields["weight"];

		$PluginRackContent->add($values);
	}

	return $space_left;
}

function plugin_rack_deleteDevice($ID) {
	$PluginRackContent = new PluginRackContent;
	$PluginRackContent->delete(array("ID"=>$ID));
}

function plugin_rack_updateOthers($ID,$name){

	$PluginRackOthers = new PluginRackOthers;
	$values["ID"] = $ID;
	$values["name"] = $name;

	$PluginRackOthers->update($values);

}

function plugin_rack_updateDevice($ID, $type, $spec,$FK_rack, $rack_size, $face, $FK_device, $position, $alim1, $alim2, $amps, $flow_rate, $dissipation, $weight) {

	$space_left = plugin_rack_checkPosition($FK_rack,$rack_size, $face, $FK_device, $type, $spec, $position);

	if ($space_left >= 0) {
		$PluginRackContent = new PluginRackContent;
		$values["ID"] = $ID;
		$values["position"] = $position;
		$values["first_powersupply"] = $alim1;
		$values["second_powersupply"] = $alim2;
		$values["amps"]=$amps;
		$values["flow_rate"]=$flow_rate;
		$values["dissipation"] = $dissipation;
		$values["weight"] = $weight;
		$PluginRackContent->update($values);
	}

	return $space_left;
}

?>