<?php
/*
   ----------------------------------------------------------------------
   GLPI - Gestionnaire Libre de Parc Informatique
   Copyright (C) 2003-2005 by the INDEPNET Development Team.

   http://indepnet.net/   http://glpi-project.org/
   ----------------------------------------------------------------------

   LICENSE

   This file is part of GLPI.

   GLPI is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GLPI is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GLPI; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Béchu Philippe
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')){
	die("Sorry. You can't access directly to this file");
	}

function plugin_rack_getTypes () {
	static $types = array(
		COMPUTER_TYPE,NETWORKING_TYPE,PERIPHERAL_TYPE
		);
	return $types;	
}

function plugin_rack_dropdownAlim($name,$value,$full=true)
{
	dropdownValue("glpi_dropdown_plugin_rack_ways",$name,$value,1);	
}

function plugin_rack_dropdownAllItems($myname,$value_type=0,$value=0,$entity_restrict=-1,$types='') {
	global $DB,$LANG,$CFG_GLPI;
	
	if (!is_array($types)){
		$types=$CFG_GLPI["state_types"];
	}
		    
	$rand=mt_rand();
	$ci=new CommonItem();
	$options=array();
	
	foreach ($types as $type){
		$ci->setType($type);
		$options[$type]=$ci->getType();
	}
	asort($options);
	if (count($options)){
		echo "<table border='0'><tr><td>\n";
	
		echo "<select name='type' id='item_type$rand'>\n";
		echo "<option value='0;0'>-----</option>\n";
		
		echo "<option value='".COMPUTER_TYPE.";glpi_dropdown_model'>".$LANG['Menu'][0]."</option>\n";
		echo "<option value='".NETWORKING_TYPE.";glpi_dropdown_model_networking'>".$LANG['Menu'][1]."</option>\n";
		echo "<option value='".PERIPHERAL_TYPE.";glpi_dropdown_model_peripherals'>".$LANG['Menu'][16]."</option>\n";
		echo "<option value='".PLUGIN_RACK_OTHERS_TYPE.";glpi_dropdown_plugin_rack_others_type'>".$LANG['plugin_rack'][43]."</option>\n";
		echo "</select>";

		$params=array('idtable'=>'__VALUE__',
			'value'=>$value,
			'myname'=>$myname,
			'entity_restrict'=>$entity_restrict,
			);
		ajaxUpdateItemOnSelectEvent("item_type$rand","show_$myname$rand",$CFG_GLPI["root_doc"]."/plugins/rack/ajax/dropdownAllItems.php",$params);

		echo "</td><td>\n"	;
		echo "<span id='show_$myname$rand'>&nbsp;</span>\n";
		echo "</td></tr></table>\n";

		if ($value>0){
			echo "<script type='text/javascript' >\n";
			echo "document.getElementById('item_type$rand').value='".$value_type."';";
			echo "</script>\n";

			$params["idtable"]=$value_type;
			ajaxUpdateItem("show_$myname$rand",$CFG_GLPI["root_doc"]."/plugins/rack/ajax/dropdownAllItems.php",$params);
			
		}
	}
	return $rand;
}

function plugin_rack_dropdownRoomLocations($name,$value,$entity,$location)
{
	global $DB;
	$used = array();
	
	dropdownValue("glpi_dropdown_plugin_rack_room_locations","room_location",$value,1,'',$used);
}
?>