<?php


/*
   ----------------------------------------------------------------------
   GLPI - Gestionnaire Libre de Parc Informatique
   Copyright (C) 2003-2005 by the INDEPNET Development Team.

   http://indepnet.net/   http://glpi-project.org/
   ----------------------------------------------------------------------

   LICENSE

   This file is part of GLPI.

   GLPI is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GLPI is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GLPI; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Béchu Philippe
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

class PluginRackModel extends CommonDBTM {

	function __construct() {
		$this->table = "glpi_plugin_rack_device_spec";
	}
	
	function showForm($target,$type,$withtemplate='') {
		global $LANG, $CFG_GLPI, $DB;
		
		$rand=mt_rand();
		
		echo "<div align='center'>";
		echo "<div align='center'><form method='post' name='massiveaction_form$rand' id='massiveaction_form$rand'  action=\"$target\">";
		
		$this->showTabs("", $withtemplate,$_SESSION['glpi_plugin_rack_tab']);

		$this->showModel($type,$rand);
	}

	function showModel($type,$rand)
	{
		
		global $LANG,$DB,$CFG_GLPI;
			
			$PluginRackConfig = new PluginRackConfig();
			$PluginRackConfig->GetfromDB(1);
		
			echo "<table class='tab_cadre_fixe' cellpadding='5'>";
			echo "<tr class='tab_bg_1'>";
			echo "<th></th>";
			echo "<th>" . $LANG['plugin_rack'][16] . "</th>";
			echo "<th>" . $LANG['plugin_rack'][6] . "</th>";
			echo "<th>" . $LANG['plugin_rack']['device'][3] . "<br>(amps)</th>";
			echo "<th>" . $LANG['plugin_rack'][45] . "</th>";
			echo "<th>".$LANG['plugin_rack']['device'][4]."<br>"; // Dissipation calorifique
			if ($PluginRackConfig->fields["unit"]=='1') 
				echo " (".$LANG['plugin_rack'][33].")";
			else
				echo " (".$LANG['plugin_rack'][34].")";
			echo "</th>";
			echo "<th>".$LANG['plugin_rack']['device'][7]."<br>"; // Débit d'air frais
			if ($PluginRackConfig->fields["unit"]=='1') 
				echo " (".$LANG['plugin_rack'][35].")";
			else
				echo " (".$LANG['plugin_rack'][36].")";
			echo "</th>";
			echo "<th>" . $LANG['plugin_rack']['device'][5] . "</th>";
			echo "<th>".$LANG['plugin_rack']['device'][6]."<br>"; // poids
			if ($PluginRackConfig->fields["unit"]=='1') 
				echo " (".$LANG['plugin_rack'][31].")";
			else
				echo " (".$LANG['plugin_rack'][32].")";
			echo "</th>";
			echo "<th>" . $LANG['plugin_rack'][23] . "</th>";
			echo "</tr>";

			$result = $DB->query("SELECT * 
									FROM `glpi_plugin_rack_device_spec` ".($type != -1?"WHERE `device_type` = '$type'":""));
			while ($data0 = $DB->fetch_assoc($result)) {
				$ID0 = $data0['ID'];
				echo "<tr class='tab_bg_1'>";
				echo "<td align='center'>";
				echo "<input type='hidden' name='ID' value='$ID0'>";
				echo "<input type='checkbox' name='item[$ID0]' value='1'>";
				echo "</td>";
				switch ($data0["device_type"])
				{
					case COMPUTER_TYPE:
						echo "<td><a href='./plugin_rack.model.form.php?ID=$ID0&type=$type'>" . getdropdownname("glpi_dropdown_model", $data0["FK_model"]) . "</a></td>";
						echo "<td>" . $LANG['common'][52] . "</td>";
						break;
					case NETWORKING_TYPE:
						echo "<td><a href='./plugin_rack.model.form.php?ID=$ID0&type=$type'>" . getdropdownname("glpi_dropdown_model_networking", $data0["FK_model"]) . "</a></td>";
						echo "<td>" . $LANG['Menu'][1] . "</td>";
						break;
					case PERIPHERAL_TYPE:
						echo "<td><a href='./plugin_rack.model.form.php?ID=$ID0&type=$type'>" . getdropdownname("glpi_dropdown_model_peripherals", $data0["FK_model"]) . "</a></td>";
						echo "<td>" . $LANG['computers'][46] . "</td>";
						break;
					case PLUGIN_RACK_OTHERS_TYPE:
						echo "<td><a href='./plugin_rack.model.form.php?ID=$ID0&type=$type'>" . getdropdownname("glpi_dropdown_plugin_rack_others_type", $data0["FK_model"]) . "</a></td>";
						echo "<td>" . $LANG['plugin_rack'][43] . "</td>";
						break;														
				}
				
				echo "<td>" . formatNumber($data0['amps'],true) . "</td>";
				echo "<td>" . $data0['nb_alim'] . "</td>";
				echo "<td>" . formatNumber($data0['dissipation'],true) . "</td>";
				echo "<td>" . formatNumber($data0['flow_rate'],true) . "</td>";
				echo "<td>" . $data0['size'] . "</td>";
				echo "<td>" . formatNumber($data0['weight'],true) . "</td>";
				echo "<td>" . getyesno($data0['length']) . "</td>";
			}

			echo "<tr class='tab_bg_1'><td colspan='10'>";
			if (plugin_rack_haveRight("model","w"))
			{
				echo "<div align='center'><a onclick= \"if ( markCheckboxes('massiveaction_form$rand') ) return false;\" href='" . $_SERVER['PHP_SELF'] . "?select=all'>" . $LANG['buttons'][18] . "</a>";
				echo " - <a onclick= \"if ( unMarkCheckboxes('massiveaction_form$rand') ) return false;\" href='" . $_SERVER['PHP_SELF'] . "?select=none'>" . $LANG['buttons'][19] . "</a> ";
				echo "<input type='submit' name='delete_Spec' value=\"" . $LANG['buttons'][6] . "\" class='submit' ></div></td></tr>";
				echo "</table></form></div>";
				if ($type != -1)
					$this->showAddNewModel($CFG_GLPI['root_doc']."/plugins/rack/front/plugin_rack.model.php", $type);
				else
				{
					$this->showAddNewModel($CFG_GLPI['root_doc']."/plugins/rack/front/plugin_rack.model.php", COMPUTER_TYPE);
					$this->showAddNewModel($CFG_GLPI['root_doc']."/plugins/rack/front/plugin_rack.model.php", NETWORKING_TYPE);
					$this->showAddNewModel($CFG_GLPI['root_doc']."/plugins/rack/front/plugin_rack.model.php", PERIPHERAL_TYPE);
					$this->showAddNewModel($CFG_GLPI['root_doc']."/plugins/rack/front/plugin_rack.model.php", PLUGIN_RACK_OTHERS_TYPE);
				}	
			}
			else
				echo "</table></form></div>";
	}
	
	
	function showAddNewModel($target,$type,$ID=-1,$withtemplate=0) {
		global $LANG, $DB,$LINK_ID_TABLE,$CFG_GLPI;
		
		$mon_spotted = false;

		if(empty($ID) && $withtemplate == 1 ||$ID==-1) {
			if($this->getEmpty())
				$mon_spotted = true;
		} else {
			if($this->getfromDB($ID)) 
				$mon_spotted = true;
		}

		if($mon_spotted) {
		
			$PluginRackConfig = new PluginRackConfig();
			$PluginRackConfig->GetfromDB(1);
				
			echo "<div align='center'>";
			echo "<form method='post' name='device_spec_form' id='device_spec_form'  action=\"$target\">";
			echo "<table class='tab_cadre_fixe' cellpadding='5'>";
			echo "<tr class='tab_bg_1'>";
			echo "<th colspan='10' align='center'>";
			
			switch ($type)
			{
				case COMPUTER_TYPE:
					if(empty($ID) ||$ID==-1)
						echo $LANG['plugin_rack']['setup'][0];
					else
						echo $LANG['plugin_rack']['setup'][4];
					break;
				case NETWORKING_TYPE:
					if(empty($ID) ||$ID==-1)
						echo $LANG['plugin_rack']['setup'][1];
					else
						echo $LANG['plugin_rack']['setup'][5];
					break;
				case PERIPHERAL_TYPE:
					if(empty($ID) ||$ID==-1)
						echo $LANG['plugin_rack']['setup'][3];
					else
						echo $LANG['plugin_rack']['setup'][7];
					break;
				case PLUGIN_RACK_OTHERS_TYPE:
					if(empty($ID) ||$ID==-1)
						echo $LANG['plugin_rack']['setup'][2];
					else
						echo $LANG['plugin_rack']['setup'][6];
					break;	
			}
				
			echo "</th></tr>";
			echo "<th></th>";
			echo "<th>" . $LANG['plugin_rack'][16] . "</th>";
			echo "<th>" . $LANG['plugin_rack']['device'][3] . "<br>(amps)</th>";
			echo "<th>" . $LANG['plugin_rack'][45] . "</th>";
			echo "<th>".$LANG['plugin_rack']['device'][4]."<br>"; // Dissipation calorifique
			if ($PluginRackConfig->fields["unit"]=='1'){
				echo " (".$LANG['plugin_rack'][33].")";
			}else{
				echo " (".$LANG['plugin_rack'][34].")";
			}
			echo "</th>";
			echo "<th>".$LANG['plugin_rack']['device'][7]."<br>"; // Débit d'air frais
			if ($PluginRackConfig->fields["unit"]=='1') {
				echo " (".$LANG['plugin_rack'][35].")";
			}else{
				echo " (".$LANG['plugin_rack'][36].")";
			}
			echo "</th>";
			echo "<th>" . $LANG['plugin_rack']['device'][5] . "</th>";
			echo "<th>".$LANG['plugin_rack']['device'][6]."<br>"; // poids
			if ($PluginRackConfig->fields["unit"]=='1') {
				echo " (".$LANG['plugin_rack'][31].")";
			}else{
				echo " (".$LANG['plugin_rack'][32].")";
			}
			echo "</th>";
			echo "<th>" . $LANG['plugin_rack'][23] . "</th>";
			echo "<th></th>";
			echo "</tr>";
	
			//Get all models already in use
			$used = array();
			$result = $DB->query("SELECT `FK_model` 
									FROM `glpi_plugin_rack_device_spec` ".($type != -1?"WHERE `device_type` = '$type'":""));
			while ($spec = $DB->fetch_array($result))
				$used[] = $spec["FK_model"];
			
			echo "<tr class='tab_bg_1'>";
			echo "<td align='center'>";
			switch ($type)
			{
				case COMPUTER_TYPE:
					echo $LANG['common'][52];	
					break;
				case NETWORKING_TYPE:
					echo $LANG['Menu'][1];
					break;
				case PERIPHERAL_TYPE:
					echo $LANG['computers'][46];
					break;
				case PLUGIN_RACK_OTHERS_TYPE:
					echo $LANG['plugin_rack'][43];
					break;
			}
				
			echo "</td>";
			echo "<td class='center'><input type='hidden' name='device_type' value='$type'>";
			
			switch ($type) {
				case COMPUTER_TYPE :
					$model_table = "glpi_dropdown_model";
					break;
				case NETWORKING_TYPE :
					$model_table = "glpi_dropdown_model_networking";
					break;
				case PERIPHERAL_TYPE :
					$model_table = "glpi_dropdown_model_peripherals";
					break;
				case PLUGIN_RACK_OTHERS_TYPE :
					$model_table = "glpi_dropdown_plugin_rack_others_type";
					break;
				default :
					$model_table="";	
			}
			
			dropdownValue($model_table, "model",$this->fields["FK_model"], 1,-1,"",$used);
			
			echo "</td>";
			echo "<td align='center'>";
			echo "<input type='text' name='amps' value=\"".formatNumber($this->fields["amps"],true)."\" size='10'>";
			echo "</td>";
			echo "<td align='center'>";
			if(empty($ID) ||$ID==-1){
				dropdownInteger("nb_alim", $this->fields["nb_alim"], 0, 2, 1);
			}else{
				echo $this->fields["nb_alim"];
			}
			echo "</td>";
			echo "<td align='center'>";
			echo "<input type='text' name='dissipation' value=\"".formatNumber($this->fields["dissipation"],true)."\" size='10'>";
			echo "</td>";
			echo "<td align='center'>";
			echo "<input type='text' name='flow_rate' value=\"".formatNumber($this->fields["flow_rate"],true)."\" size='10'>";
			echo "</td>";
			echo "<td align='center'>";
			if(empty($ID) ||$ID==-1){
				dropdownInteger("size", $this->fields["size"], 1, 100, 1);
			}else{
				echo $this->fields["size"];
			}
			echo " U</td>";
		
			echo "<td align='center'>";
			echo "<input type='text' name='weight' value=\"".formatNumber($this->fields["weight"],true)."\" size='10'>";
			echo "</td>";
			
			echo "<td align='center'>";
			if(empty($ID) ||$ID==-1){
				dropdownyesno("length",$this->fields["length"]);
			}else{
				echo getYesNo($this->fields["length"]);
			}
			echo "</td>";
			
			if(empty($ID) ||$ID==-1){
				echo "<td align='center'><input type='submit' name='add_Spec' value=\"" . $LANG['buttons'][8] . "\" class='submit'></td>";
			}else{
				echo "<td align='center'></td>";
			}
			echo "</tr>";
			
			if(plugin_rack_haveRight("model","w") && $ID>0){
		
				echo "<tr>";
				echo "<td class='tab_bg_2' valign='top' colspan='10'>";
				echo "<input type='hidden' name='withtemplate' value=\"".$withtemplate."\" >";
				echo "<input type='hidden' name='ID' value=\"$ID\">\n";
				echo "<div align='center'><input type='submit' name='update_Spec' value=\"".$LANG['buttons'][7]."\" class='submit' >";
				echo "</div></td>";
				echo "</tr>";
			}
				
			echo "</table>";
			echo "</form></div>";
		
		}else{
			echo "<div align='center'><b>" . $LANG['plugin_rack'][22] . "</b></div>";
			return false;
		}
		
		echo "<div align='center'><a href='".$CFG_GLPI["root_doc"]."/plugins/rack/front/plugin_rack.model.php'>".$LANG['buttons'][13]."</a></div>";
	}
}
?>