<?php

/*
   ----------------------------------------------------------------------
   GLPI - Gestionnaire Libre de Parc Informatique
   Copyright (C) 2003-2005 by the INDEPNET Development Team.

   http://indepnet.net/   http://glpi-project.org/
   ----------------------------------------------------------------------

   LICENSE

   This file is part of GLPI.

   GLPI is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   GLPI is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GLPI; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Béchu Philippe
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')) {
	die("Sorry. You can't access directly to this file");
}

// CLASSES rack
class PluginRackConfig extends CommonDBTM {

	function __construct() {
		$this->table = "glpi_plugin_rack_config";
	}
}

class PluginRackOthers extends CommonDBTM {

	function __construct() {
		$this->table = "glpi_plugin_rack_others";
		$this->type = PLUGIN_RACK_OTHERS_TYPE;
		$this->entity_assign = true;
		$this->may_be_recursive = true;
		$this->dohistory = true;
	}
}

class PluginRackDeviceSpec extends CommonDBTM {

	function __construct() {
		$this->table = "glpi_plugin_rack_device_spec";
	}

	function getEmpty() {
		$this->fields["amps"] = 0.0000;
		$this->fields["flow_rate"] = 0.0000;
		$this->fields["dissipation"] = 0.0000;
		$this->fields["weight"] = 0.0000;
		return true;		
	}
}

class PluginRackContent extends CommonDBTM {

	function __construct() {
		$this->table = "glpi_plugin_rack_content";
	}

	function getEmpty() {
		$this->fields["FK_rack"] = 0;
		$this->fields["FK_device"] = 0;
		$this->fields["device_type"] = 0;
		$this->fields["position"] = 1;
		$this->fields["alim1"] = 0;
		$this->fields["alim2"] = 0;
		$this->fields["amps"] = 0.0000;
		$this->fields["flow_rate"] = 0.0000;
		$this->fields["dissipation"] = 0.0000;
		$this->fields["weight"] = 0.0000;
		return true;		
	}
}

class PluginRack extends CommonDBTM {

	function __construct() {
		$this->table = "glpi_plugin_rack";
		$this->type = PLUGIN_RACK_TYPE;
		$this->entity_assign = true;
		$this->may_be_recursive = true;
		$this->dohistory = true;
	}
/*
	function getEmpty() {
		$this->fields["name"] = "";
		$this->fields["tplname"] = "";
		$this->fields["is_template"] = 0;
		$this->fields["recursive"] = 0;
		$this->fields["FK_glpi_enterprise"] = 0;
		$this->fields["FK_entities"]=$_SESSION["glpiactive_entity"];
		return true;
	}
*/
	function cleanDBonPurge($ID) {
		global $DB;

		$query = "DELETE 
					FROM `glpi_plugin_rack_content` 
					WHERE `FK_rack` = '$ID'";
		$DB->query($query);
		$query = "DELETE 
					FROM `glpi_doc_device` 
					WHERE `FK_device` = '$ID' 
					AND `device_type` = '" . PLUGIN_RACK_TYPE . "' ";
		$DB->query($query);

	}

	function cleanItems($ID, $type) {

		global $DB;

		$query = "DELETE 
					FROM `glpi_plugin_rack_content` 
					WHERE `FK_device` = '$ID' 
					AND `device_type` = '$type'";
		$DB->query($query);
	}

	function defineTabs($ID,$withtemplate) {
		global $LANG;
		$ong[1] = $LANG['title'][26];
		if ($ID > 0){
			$ong[2] = $LANG['plugin_rack'][46];
			$ong[3] = $LANG['plugin_rack'][47];
			//$ong[4] = $LANG['plugin_rack'][48];
			//$ong[5] = $LANG['plugin_rack'][49];
			//documents
			if (haveRight("document", "r"))
				$ong[9] = $LANG['Menu'][27];
			if(empty($withtemplate)){
			//notes
			if (haveRight("notes", "r"))
				$ong[10] = $LANG['title'][37];
	
			$ong[12]=$LANG['title'][38];
			}
		}
		return $ong;
	}
	
	function prepareInputForAdd($input) {
		
		if (isset($input["ID"])&&$input["ID"]>0){
			$input["_oldID"]=$input["ID"];
		}
		unset($input['withtemplate']);
		unset($input['ID']);

		return $input;
	}
	
	function post_addItem($newID,$input) {
		global $DB;
		
		// Manage add from template
		if (isset($input["_oldID"])){
			
			// ADD documents
			$query_old_documents="SELECT `ID` 
									FROM `glpi_doc_device` 
									WHERE `FK_device` = '".$input["_oldID"]."' 
									AND `device_type` = '".PLUGIN_RACK_TYPE."';";
			$result_old_documents=$DB->query($query_old_documents);
			if ($DB->numrows($result_old_documents)>0){
	
				while ($data_old_documents=$DB->fetch_array($result_old_documents)){
	
					$query_documents="SELECT * FROM `glpi_doc_device` WHERE `ID` ='".$data_old_documents["ID"]."' ";
					$result_documents=$DB->query($query_documents);
					if ($DB->numrows($result_documents)>0){
	
						while ($data_documents=$DB->fetch_array($result_documents)){
							addDeviceDocument($data_documents["FK_doc"],PLUGIN_RACK_TYPE,$newID);
						}
					}			 
				}
			}
		}
	}
	
	function showForm($target,$ID,$withtemplate='')
	{
		global $LANG, $CFG_GLPI;
		
		if (!plugin_rack_haveRight("rack","r")) return false;
		
		$mon_spotted = false;

		if(empty($ID) && $withtemplate == 1 ||$ID==-1) {
			if($this->getEmpty()) $mon_spotted = true;
		} else {
			if($this->getfromDB($ID)&&haveAccessToEntity($this->fields["FK_entities"])) $mon_spotted = true;
		}

		if($mon_spotted) {
				
			$this->showTabs($ID, $withtemplate,$_SESSION['glpi_tab']);
			
			if(!empty($withtemplate) && $withtemplate == 2) {
				$template = "newcomp";
			} elseif(!empty($withtemplate) && $withtemplate == 1) { 
				$template = "newtemplate";
			} else {
				$template = false;
			}
		
			$canedit = $this->can($ID, 'w');
			$canrecu = $this->can($ID, 'recursive');
			
			$PluginRackConfig = new PluginRackConfig();
			$PluginRackConfig->GetfromDB(1);
			
			echo "<form method='post' name=form action=\"$target\">";
			echo "<input type='hidden' name='FK_entities' value='".$this->fields["FK_entities"]."'>";
			echo "<div class='center' id='tabsbody'>";
			echo "<table class='tab_cadre_fixe'>";
			
			$this->showFormHeader($ID, $withtemplate,3);
			
			//ligne 1
			echo "<tr class='tab_bg_1'>";
			
			echo "<td>" . $LANG['plugin_rack'][5] . ": </td><td>";
			autocompletionTextField("name", "glpi_plugin_rack", "name", $this->fields["name"], 40, $this->fields["name"]);
			echo "</td>";
			
			echo "<td >" . $LANG['common'][15] . ": 	</td>";
			echo "<td>";
			dropdownValue("glpi_dropdown_locations", "FK_location", $this->fields["FK_location"], 1,$this->fields["FK_entities"]);
			echo "</td>";
			
			echo "<td>" . $LANG['plugin_rack'][40] . ": </td><td>";
			echo "<input type='text' name='height' value=\"".formatNumber($this->fields["height"],true)."\" size='10'>";
			if ($PluginRackConfig->fields["unit"]=='1') 
				echo " ".$LANG['plugin_rack'][37];
			else
				echo " ".$LANG['plugin_rack'][38];
			echo "</td>";
			
			echo "</tr>";
			//ligne 2
			echo "<tr class='tab_bg_1'>";
			
			echo "<td>" . $LANG['common'][5] . ": </td><td>";
			dropdownValue("glpi_dropdown_manufacturer", "FK_glpi_enterprise", $this->fields["FK_glpi_enterprise"]);
			echo "</td>";
			
			echo "<td>" . $LANG['plugin_rack'][11].": ";
			echo "</td><td>";
			plugin_rack_dropdownRoomLocations("room_location",$this->fields["room_location"],$this->fields["FK_entities"],$this->fields["FK_location"]);
			echo "</td>";
			
			echo "<td>" . $LANG['plugin_rack'][41] . ": </td><td>";
			echo "<input type='text' name='width' value=\"".formatNumber($this->fields["width"],true)."\" size='10'>";
			if ($PluginRackConfig->fields["unit"]=='1') 
				echo " ".$LANG['plugin_rack'][37];
			else
				echo " ".$LANG['plugin_rack'][38];
			echo "</td>";
			
			echo "</tr>";
			//ligne 3
			echo "<tr class='tab_bg_1'>";
			
			echo "<td >".$LANG['common'][10].": </td>";
			echo "<td >";
			dropdownUsersID("tech_num",$this->fields["tech_num"],"interface",1,$this->fields["FK_entities"]);
			echo "</td>";
			
			echo "<td>" . $LANG['plugin_rack'][12] . ": </td><td>";
			dropdownInteger("rack_size", $this->fields["rack_size"], 1, 100, 1);		
			echo " U</td>";
			
			echo "<td>" . $LANG['plugin_rack'][42] . ": </td><td>";
			echo "<input type='text' name='depth' value=\"".formatNumber($this->fields["depth"],true)."\" size='10'>";
			if ($PluginRackConfig->fields["unit"]=='1') 
				echo " ".$LANG['plugin_rack'][37];
			else
				echo " ".$LANG['plugin_rack'][38];
			echo "</td>";
			
			echo "</tr>";
			
			//ligne 4
			echo "<tr class='tab_bg_1'>";
			
			echo "<td>".$LANG['common'][35].":</td><td>";
			dropdownValue("glpi_groups", "FK_groups", $this->fields["FK_groups"],1,$this->fields["FK_entities"]);
			echo "</td>";
		
			echo "<td>" . $LANG['plugin_rack']['device'][6] . ": </td><td>";
			echo "<input type='text' name='weight' value=\"".formatNumber($this->fields["weight"],true)."\" size='10'>";
			if ($PluginRackConfig->fields["unit"]=='1') 
				echo " ".$LANG['plugin_rack'][31];
			else
				echo " ".$LANG['plugin_rack'][32];
			echo "</td>";
			
			echo "<td colspan='2'></td>";
			echo "</tr>";

			
			if(plugin_rack_haveRight("rack","w")){
				if ($template) {
					if (empty($ID)||$withtemplate==2){
						echo "<tr>";
						echo "<td class='tab_bg_2' valign='top' colspan='6'>";
						echo "<input type='hidden' name='withtemplate' value=\"".$withtemplate."\" >";
						echo "<input type='hidden' name='ID' value=$ID>";
						echo "<div align='center'><input type='submit' name='add' value=\"".$LANG['buttons'][8]."\" class='submit'>";
						echo "</div></td>";
						echo "</tr>";
					} else {
						
						echo "<tr>";
						echo "<td class='tab_bg_2' valign='top' colspan='6'>";
						echo "<input type='hidden' name='withtemplate' value=\"".$withtemplate."\" >";
						echo "<input type='hidden' name='ID' value=$ID>";
						echo "<div align='center'><input type='submit' name='update' value=\"".$LANG['buttons'][7]."\" class='submit'>";
						echo "</div></td>";
						echo "</tr>";
					}
				} else {
	
					echo "<tr>";
					echo "<td class='tab_bg_2' valign='top' colspan='6'>";
					echo "<input type='hidden' name='withtemplate' value=\"".$withtemplate."\" >";
					echo "<input type='hidden' name='ID' value=\"$ID\">\n";
					echo "<div align='center'><input type='submit' name='update' value=\"".$LANG['buttons'][7]."\" class='submit' >";
				
					if ($this->fields["deleted"]=='0')
						echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type='submit' name='delete' value=\"".$LANG['buttons'][6]."\" class='submit'>";
					else {
						echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type='submit' name='restore' value=\"".$LANG['buttons'][21]."\" class='submit'>";
	
						echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type='submit' name='purge' value=\"".$LANG['buttons'][22]."\" class='submit'>";
					}
					echo "</div></td>";
					echo "</tr>";
				}
			}		
			
			echo "</table></div></form>";
			echo "<div id='tabcontent'></div>";
			echo "<script type='text/javascript'>loadDefaultTab();</script>";
		}
		else
		{
			echo "<div align='center'><b>" . $LANG['plugin_rack'][8] . "</b></div>";
			return false;
		}
	}
}

?>