<?php

/*
 * @version $Id: setup.php,v 1.2 2006/04/02 14:45:27 moyo Exp $
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2006 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Béchu Philippe
// Purpose of file:
// ----------------------------------------------------------------------

include_once ("inc/plugin_rack.auth.function.php");
include_once ("inc/plugin_rack.profile.class.php");

function plugin_init_rack() {
	global $PLUGIN_HOOKS, $CFG_GLPI, $LANG;

	$PLUGIN_HOOKS['change_profile']['rack'] = 'plugin_rack_changeProfile';
	
	// Params : plugin name - string type - number - attributes
	registerPluginType('rack', 'PLUGIN_RACK_TYPE', 4450, array(
		'classname'  => 'PluginRack',
		'tablename'  => 'glpi_plugin_rack',
		'formpage'   => 'front/plugin_rack.form.php',
		'searchpage' => 'index.php',
		'typename'   => $LANG['plugin_rack']['title'][1],
		'deleted_tables' => true,
		'specif_entities_tables' => true,
		'template_tables' => true,
		'recursive_type' => true,
		'doc_types' => true
		));
	
	registerPluginType('rack', 'PLUGIN_RACK_OTHERS_TYPE', 4451, array(
		'classname'  => 'PluginRackOthers',
		'tablename'  => 'glpi_plugin_rack_others',
		'typename'   => $LANG['plugin_rack'][43]
		));
			
	if (isset ($_SESSION["glpiID"])) {

		array_push($CFG_GLPI["specif_entities_tables"], "glpi_dropdown_plugin_rack_room_locations");
		array_push($CFG_GLPI["dropdowntree_tables"],"glpi_dropdown_plugin_rack_room_locations");
		
		// Display a menu entry ?
		if (plugin_rack_haveRight("rack", "r")) {
			$PLUGIN_HOOKS['menu_entry']['rack'] = true;
			$PLUGIN_HOOKS['submenu_entry']['rack']['search'] = 'index.php';
			$PLUGIN_HOOKS['headings']['rack'] = 'plugin_get_headings_rack';
			$PLUGIN_HOOKS['headings_action']['rack'] = 'plugin_headings_actions_rack';
			$PLUGIN_HOOKS['submenu_entry']['rack']['add'] = 'front/plugin_rack.template.php?add=1';
		}

		if (plugin_rack_haveRight("model", "r"))
		{
			$PLUGIN_HOOKS['submenu_entry']['rack']['template'] = 'front/plugin_rack.template.php?add=0';
			$PLUGIN_HOOKS['submenu_entry']['rack']["<img  src='".$CFG_GLPI["root_doc"]."/pics/menu_showall.png' title=\"".$LANG['plugin_rack']['setup'][12]."\" alt=\"".$LANG['plugin_rack']['setup'][12]."\">"] = 'front/plugin_rack.model.php';
			
		}
			
		if (plugin_rack_haveRight("rack", "r")) {
			{
				$PLUGIN_HOOKS['submenu_entry']['rack']['config'] = 'front/plugin_rack.config.php';
				$PLUGIN_HOOKS['pre_item_delete']['rack'] = 'plugin_pre_item_delete_rack';
				$PLUGIN_HOOKS['item_purge']['rack'] = 'plugin_item_purge_rack';
				$PLUGIN_HOOKS['use_massive_action']['rack'] = 1;
			}
		}
		
		// Config page
		if (plugin_rack_haveRight("rack", "w") || haveRight("config", "w"))
			$PLUGIN_HOOKS['config_page']['rack'] = 'front/plugin_rack.config.php';
			
		// Add specific files to add to the header : javascript or css
		//$PLUGIN_HOOKS['add_javascript']['example']="example.js";
		$PLUGIN_HOOKS['add_css']['rack'] = "rack.css";
	}
}

function plugin_version_rack() {

	global $LANG;

	return array (
		'name' => $LANG['plugin_rack']['title'][1],
		'version' => '1.0.3',
		'author'=>'Philippe Béchu, Walid Nouh, Xavier Caillaud',
		'homepage'=>'https://forge.indepnet.net/projects/show/racks',
		'minGlpiVersion' => '0.72',// For compatibility / no install in version < 0.72
	);
}

// Optional : check prerequisites before install : may print errors or add to message after redirect
function plugin_rack_check_prerequisites(){
	if (GLPI_VERSION>=0.72){
		return true;
	} else {
		echo "GLPI version not compatible need 0.72";
	}
}

// Uninstall process for plugin : need to return true if succeeded : may display messages or add to message after redirect
function plugin_rack_check_config(){
	return true;
}

// Define rights for the plugin types
function plugin_rack_haveTypeRight($type, $right) {
	switch ($type) {
		case PLUGIN_RACK_TYPE :
			// 1 - All rights for all users
			// return true;
			// 2 - Similarity right : same right of computer
			return plugin_rack_haveRight("rack", $right);
			break;
	}
}

?>